<?
/////////////////////////////////////////////////////////////////////////////
// Generic template object
// $tpl is an array indexed with "elements", each element has a key and a
// value.
// During compilation the matched keys are replaced with the given values
//
// example : $tpl['table'] = "<table>{CONTENTS}</table>";
//           compile('table', array('{CONTENTS}' => '<tr><td>aaa</td></tr>'));
//           Here compile will return '<table><tr><td>aaa</td></tr></table>';

class CTemplate extends CClass {
  var $tpl;
  var $files;
  var $fileLoaded;
  var $compiledOutput;

  ///////////////////////////////////////////////////////////////////////////
  function compile($element, $data) {
    $this->compiledOutput = $this->tpl[$element];

    foreach ($data as $k => $v) {
      $this->compiledOutput = str_replace($k, $v, $this->compiledOutput);
    }
    
    return $this->compiledOutput;    
  }

  ///////////////////////////////////////////////////////////////////////////
  function setFiles($files) {
    $this->files = $files;
  }
  
  ///////////////////////////////////////////////////////////////////////////
  // loads specified components
  function load($files) {
    $success = true;
    
    foreach ($files as $file) {
      if ((($f = fopen($this->files[$file], "rt")) != FALSE) &&
          (!$this->fileLoaded[$file])) {
        $this->tpl[$file] = fread($f, filesize($this->files[$file]));
        fclose($f);
        $this->fileLoaded[$file] = true;
      } else {
        $success = false;
        $this->fileLoaded[$file] = false;
      }
    }

    return $success;
  }
};
?>
